/**
 */
package org.etsi.mts.tdl.impl;

import java.lang.reflect.InvocationTargetException;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.etsi.mts.tdl.CollectionDataInstance;
import org.etsi.mts.tdl.CollectionDataType;
import org.etsi.mts.tdl.DataElementUse;
import org.etsi.mts.tdl.DataInstance;
import org.etsi.mts.tdl.DataInstanceUse;
import org.etsi.mts.tdl.DataType;
import org.etsi.mts.tdl.DataUse;
import org.etsi.mts.tdl.Element;
import org.etsi.mts.tdl.Member;
import org.etsi.mts.tdl.MemberAssignment;
import org.etsi.mts.tdl.Parameter;
import org.etsi.mts.tdl.ParameterBinding;
import org.etsi.mts.tdl.UnassignedMemberTreatment;
import org.etsi.mts.tdl.tdlPackage;
import org.etsi.mts.tdl.tdlTables;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Instance Use</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.etsi.mts.tdl.impl.DataInstanceUseImpl#getDataInstance <em>Data Instance</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.DataInstanceUseImpl#getUnassignedMember <em>Unassigned Member</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.DataInstanceUseImpl#getDataType <em>Data Type</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.DataInstanceUseImpl#getItem <em>Item</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DataInstanceUseImpl extends StaticDataUseImpl implements DataInstanceUse
{
	/**
	 * The cached value of the '{@link #getDataInstance() <em>Data Instance</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataInstance()
	 * @generated
	 * @ordered
	 */
	protected DataInstance dataInstance;

	/**
	 * The default value of the '{@link #getUnassignedMember() <em>Unassigned Member</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnassignedMember()
	 * @generated
	 * @ordered
	 */
	protected static final UnassignedMemberTreatment UNASSIGNED_MEMBER_EDEFAULT = UnassignedMemberTreatment.UNDEFINED;

	/**
	 * The cached value of the '{@link #getUnassignedMember() <em>Unassigned Member</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnassignedMember()
	 * @generated
	 * @ordered
	 */
	protected UnassignedMemberTreatment unassignedMember = UNASSIGNED_MEMBER_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDataType() <em>Data Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataType()
	 * @generated
	 * @ordered
	 */
	protected DataType dataType;

	/**
	 * The cached value of the '{@link #getItem() <em>Item</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getItem()
	 * @generated
	 * @ordered
	 */
	protected EList<DataUse> item;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataInstanceUseImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return tdlPackage.Literals.DATA_INSTANCE_USE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public DataInstance getDataInstance()
	{
		if (dataInstance != null && dataInstance.eIsProxy()) {
			InternalEObject oldDataInstance = (InternalEObject)dataInstance;
			dataInstance = (DataInstance)eResolveProxy(oldDataInstance);
			if (dataInstance != oldDataInstance) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, tdlPackage.DATA_INSTANCE_USE__DATA_INSTANCE, oldDataInstance, dataInstance));
			}
		}
		return dataInstance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataInstance basicGetDataInstance()
	{
		return dataInstance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDataInstance(DataInstance newDataInstance)
	{
		DataInstance oldDataInstance = dataInstance;
		dataInstance = newDataInstance;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, tdlPackage.DATA_INSTANCE_USE__DATA_INSTANCE, oldDataInstance, dataInstance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public UnassignedMemberTreatment getUnassignedMember()
	{
		return unassignedMember;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setUnassignedMember(UnassignedMemberTreatment newUnassignedMember)
	{
		UnassignedMemberTreatment oldUnassignedMember = unassignedMember;
		unassignedMember = newUnassignedMember == null ? UNASSIGNED_MEMBER_EDEFAULT : newUnassignedMember;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, tdlPackage.DATA_INSTANCE_USE__UNASSIGNED_MEMBER, oldUnassignedMember, unassignedMember));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public DataType getDataType()
	{
		if (dataType != null && dataType.eIsProxy()) {
			InternalEObject oldDataType = (InternalEObject)dataType;
			dataType = (DataType)eResolveProxy(oldDataType);
			if (dataType != oldDataType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, tdlPackage.DATA_INSTANCE_USE__DATA_TYPE, oldDataType, dataType));
			}
		}
		return dataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataType basicGetDataType()
	{
		return dataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDataType(DataType newDataType)
	{
		DataType oldDataType = dataType;
		dataType = newDataType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, tdlPackage.DATA_INSTANCE_USE__DATA_TYPE, oldDataType, dataType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<DataUse> getItem()
	{
		if (item == null) {
			item = new EObjectContainmentEList<DataUse>(DataUse.class, this, tdlPackage.DATA_INSTANCE_USE__ITEM);
		}
		return item;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public DataType resolveDataType()
	{
		/**
		 *
		 * if not self.dataInstance.oclIsUndefined()
		 * then self.dataInstance.dataType
		 * else
		 *   if not self.dataType.oclIsUndefined()
		 *   then self.dataType
		 *   else
		 *     if self.container().oclIsTypeOf(MemberAssignment)
		 *     then
		 *       self.container()
		 *       .oclAsType(MemberAssignment).member.dataType
		 *     else
		 *       if self.container().oclIsTypeOf(ParameterBinding)
		 *       then
		 *         self.container()
		 *         .oclAsType(ParameterBinding).parameter.dataType
		 *       else
		 *         if
		 *           self.container()
		 *           .oclIsTypeOf(CollectionDataInstance)
		 *         then
		 *           self.container()
		 *           .oclAsType(CollectionDataInstance)
		 *           .dataType.oclAsType(CollectionDataType).itemType
		 *         else
		 *           if self.container().oclIsTypeOf(DataElementUse)
		 *           then
		 *             self.container()
		 *             .oclAsType(DataElementUse)
		 *             .resolveDataType()
		 *             .oclAsType(CollectionDataType).itemType
		 *           else
		 *             if self.container().oclIsTypeOf(DataInstanceUse)
		 *             then
		 *               self.container()
		 *               .oclAsType(DataInstanceUse)
		 *               .resolveDataType()
		 *               .oclAsType(CollectionDataType).itemType
		 *             else null
		 *             endif
		 *           endif
		 *         endif
		 *       endif
		 *     endif
		 *   endif
		 * endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ DataInstance dataInstance_0 = this.getDataInstance();
		final /*@NonInvalid*/ boolean oclIsUndefined = dataInstance_0 == null;
		final /*@NonInvalid*/ Boolean not;
		if (!oclIsUndefined) {
			not = ValueUtil.TRUE_VALUE;
		}
		else {
			if (oclIsUndefined) {
				not = ValueUtil.FALSE_VALUE;
			}
			else {
				not = null;
			}
		}
		if (not == null) {
			throw new InvalidValueException("Null if condition");
		}
		/*@Thrown*/ DataType local_6;
		if (not) {
			if (dataInstance_0 == null) {
				throw new InvalidValueException("Null source for \'\'http://www.etsi.org/spec/TDL/1.4.1\'::DataInstance::dataType\'");
			}
			final /*@Thrown*/ DataType dataType = dataInstance_0.getDataType();
			local_6 = dataType;
		}
		else {
			final /*@NonInvalid*/ DataType dataType_1 = this.getDataType();
			final /*@NonInvalid*/ boolean oclIsUndefined_0 = dataType_1 == null;
			final /*@NonInvalid*/ Boolean not_0;
			if (!oclIsUndefined_0) {
				not_0 = ValueUtil.TRUE_VALUE;
			}
			else {
				if (oclIsUndefined_0) {
					not_0 = ValueUtil.FALSE_VALUE;
				}
				else {
					not_0 = null;
				}
			}
			if (not_0 == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@Thrown*/ DataType local_5;
			if (not_0) {
				local_5 = dataType_1;
			}
			else {
				final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_MemberAssignment_0 = idResolver.getClass(tdlTables.CLSSid_MemberAssignment, null);
				final /*@NonInvalid*/ Element container = this.container();
				final /*@NonInvalid*/ boolean oclIsTypeOf = OclAnyOclIsTypeOfOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_MemberAssignment_0).booleanValue();
				/*@Thrown*/ DataType local_4;
				if (oclIsTypeOf) {
					final /*@Thrown*/ MemberAssignment oclAsType = (MemberAssignment)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_MemberAssignment_0);
					final /*@Thrown*/ Member member = oclAsType.getMember();
					final /*@Thrown*/ DataType dataType_2 = member.getDataType();
					local_4 = dataType_2;
				}
				else {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_ParameterBinding_0 = idResolver.getClass(tdlTables.CLSSid_ParameterBinding, null);
					final /*@NonInvalid*/ boolean oclIsTypeOf_0 = OclAnyOclIsTypeOfOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_ParameterBinding_0).booleanValue();
					/*@Thrown*/ DataType local_3;
					if (oclIsTypeOf_0) {
						final /*@Thrown*/ ParameterBinding oclAsType_0 = (ParameterBinding)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_ParameterBinding_0);
						final /*@Thrown*/ Parameter parameter = oclAsType_0.getParameter();
						final /*@Thrown*/ DataType dataType_3 = parameter.getDataType();
						local_3 = dataType_3;
					}
					else {
						final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_CollectionDataInstance_0 = idResolver.getClass(tdlTables.CLSSid_CollectionDataInstance, null);
						final /*@NonInvalid*/ boolean oclIsTypeOf_1 = OclAnyOclIsTypeOfOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_CollectionDataInstance_0).booleanValue();
						/*@Thrown*/ DataType local_2;
						if (oclIsTypeOf_1) {
							final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_CollectionDataType_0 = idResolver.getClass(tdlTables.CLSSid_CollectionDataType, null);
							final /*@Thrown*/ CollectionDataInstance oclAsType_1 = (CollectionDataInstance)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_CollectionDataInstance_0);
							final /*@Thrown*/ DataType dataType_4 = oclAsType_1.getDataType();
							final /*@Thrown*/ CollectionDataType oclAsType_2 = (CollectionDataType)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, dataType_4, TYP_tdl_c_c_CollectionDataType_0);
							final /*@Thrown*/ DataType itemType = oclAsType_2.getItemType();
							local_2 = itemType;
						}
						else {
							final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_DataElementUse_0 = idResolver.getClass(tdlTables.CLSSid_DataElementUse, null);
							final /*@NonInvalid*/ boolean oclIsTypeOf_2 = OclAnyOclIsTypeOfOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_DataElementUse_0).booleanValue();
							/*@Thrown*/ DataType local_1;
							if (oclIsTypeOf_2) {
								final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_CollectionDataType_1 = idResolver.getClass(tdlTables.CLSSid_CollectionDataType, null);
								final /*@Thrown*/ DataElementUse oclAsType_3 = (DataElementUse)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_DataElementUse_0);
								final /*@Thrown*/ DataType resolveDataType = oclAsType_3.resolveDataType();
								final /*@Thrown*/ CollectionDataType oclAsType_4 = (CollectionDataType)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, resolveDataType, TYP_tdl_c_c_CollectionDataType_1);
								final /*@Thrown*/ DataType itemType_0 = oclAsType_4.getItemType();
								local_1 = itemType_0;
							}
							else {
								final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_DataInstanceUse_0 = idResolver.getClass(tdlTables.CLSSid_DataInstanceUse, null);
								final /*@NonInvalid*/ boolean oclIsTypeOf_3 = OclAnyOclIsTypeOfOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_DataInstanceUse_0).booleanValue();
								/*@Thrown*/ DataType local_0;
								if (oclIsTypeOf_3) {
									final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_CollectionDataType_2 = idResolver.getClass(tdlTables.CLSSid_CollectionDataType, null);
									final /*@Thrown*/ DataInstanceUse oclAsType_5 = (DataInstanceUse)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_DataInstanceUse_0);
									final /*@Thrown*/ DataType resolveDataType_0 = oclAsType_5.resolveDataType();
									final /*@Thrown*/ CollectionDataType oclAsType_6 = (CollectionDataType)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, resolveDataType_0, TYP_tdl_c_c_CollectionDataType_2);
									final /*@Thrown*/ DataType itemType_1 = oclAsType_6.getItemType();
									local_0 = itemType_1;
								}
								else {
									local_0 = null;
								}
								local_1 = local_0;
							}
							local_2 = local_1;
						}
						local_3 = local_2;
					}
					local_4 = local_3;
				}
				local_5 = local_4;
			}
			local_6 = local_5;
		}
		return local_6;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID) {
			case tdlPackage.DATA_INSTANCE_USE__ITEM:
				return ((InternalEList<?>)getItem()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID) {
			case tdlPackage.DATA_INSTANCE_USE__DATA_INSTANCE:
				if (resolve) return getDataInstance();
				return basicGetDataInstance();
			case tdlPackage.DATA_INSTANCE_USE__UNASSIGNED_MEMBER:
				return getUnassignedMember();
			case tdlPackage.DATA_INSTANCE_USE__DATA_TYPE:
				if (resolve) return getDataType();
				return basicGetDataType();
			case tdlPackage.DATA_INSTANCE_USE__ITEM:
				return getItem();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID) {
			case tdlPackage.DATA_INSTANCE_USE__DATA_INSTANCE:
				setDataInstance((DataInstance)newValue);
				return;
			case tdlPackage.DATA_INSTANCE_USE__UNASSIGNED_MEMBER:
				setUnassignedMember((UnassignedMemberTreatment)newValue);
				return;
			case tdlPackage.DATA_INSTANCE_USE__DATA_TYPE:
				setDataType((DataType)newValue);
				return;
			case tdlPackage.DATA_INSTANCE_USE__ITEM:
				getItem().clear();
				getItem().addAll((Collection<? extends DataUse>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID) {
			case tdlPackage.DATA_INSTANCE_USE__DATA_INSTANCE:
				setDataInstance((DataInstance)null);
				return;
			case tdlPackage.DATA_INSTANCE_USE__UNASSIGNED_MEMBER:
				setUnassignedMember(UNASSIGNED_MEMBER_EDEFAULT);
				return;
			case tdlPackage.DATA_INSTANCE_USE__DATA_TYPE:
				setDataType((DataType)null);
				return;
			case tdlPackage.DATA_INSTANCE_USE__ITEM:
				getItem().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID) {
			case tdlPackage.DATA_INSTANCE_USE__DATA_INSTANCE:
				return dataInstance != null;
			case tdlPackage.DATA_INSTANCE_USE__UNASSIGNED_MEMBER:
				return unassignedMember != UNASSIGNED_MEMBER_EDEFAULT;
			case tdlPackage.DATA_INSTANCE_USE__DATA_TYPE:
				return dataType != null;
			case tdlPackage.DATA_INSTANCE_USE__ITEM:
				return item != null && !item.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedOperationID(int baseOperationID, Class<?> baseClass)
	{
		if (baseClass == DataUse.class) {
			switch (baseOperationID) {
				case tdlPackage.DATA_USE___RESOLVE_DATA_TYPE: return tdlPackage.DATA_INSTANCE_USE___RESOLVE_DATA_TYPE;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		return super.eDerivedOperationID(baseOperationID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException
	{
		switch (operationID) {
			case tdlPackage.DATA_INSTANCE_USE___RESOLVE_DATA_TYPE:
				return resolveDataType();
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (eIsProxy()) return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (unassignedMember: ");
		result.append(unassignedMember);
		result.append(')');
		return result.toString();
	}

} //DataInstanceUseImpl
